#!/usr/bin/python
# gen-table is a script that generate tables from the info in the result tree.
#	Copyright (C) 2005  Kristian Benoit, Opersys inc.
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License
#	as published by the Free Software Foundation; either version 2
#	of the License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import analyse
import os
import sys
sys.path.append("scripts")
import analyse
from setting import *

resultdir="results"

print_head = True
if True:
	for kernel in os.listdir(resultdir):
		if not kernel[0].isdigit() or not os.path.isdir(os.path.join(resultdir, kernel)):
			continue

		if print_head:
			str1 = "+----------------------+"
			str2 = "| Kernel               |"
			str3 = "+======================+"

		line = "| %(kernel)-20.20s |" % vars()

#		for test in os.listdir(os.path.join(resultdir, kernel)):
		for test in tests_list:
			test = test["name"]
			if not os.path.isdir(os.path.join(resultdir, kernel, test)):
				continue
	
			times = []
			passes = os.listdir(os.path.join(resultdir, kernel, test))
			if not os.path.isfile(os.path.join(resultdir, kernel, test, passes[0], "lmbench.time")):
				continue
	
			if print_head:
				str1 += "------------+"
				str2 += " %(test)-10.10s |" % vars()
				str3 += "============+"

			for p in passes:
				time_file = os.path.join(resultdir, kernel, test, p, "lmbench.time")
				if os.path.isfile(time_file):
					f = file(time_file)
					times += [float(f.readline())]
			time = (sum(times) + 0.0)/len(times)
			line += " %(time)10.0f |" % vars()
	
		if print_head:
			print str1
			print str2
			print str3
			print_head = False

		print line
		print str1
	print

if True:
	print """
+----------------------+------------+------+-------+------+--------+
| Kernel               | sys load   | Aver | Max   | Min  | StdDev |
+======================+============+======+=======+======+========+"""
	
	for kernel in os.listdir(resultdir):
		if not kernel[0].isdigit() or not os.path.isdir(os.path.join(resultdir, kernel)):
			continue
	
		kernelstr = kernel
	
#		for test in os.listdir(os.path.join(resultdir, kernel)):
		for test in tests_list:
			test = test["name"]
			if not os.path.isdir(os.path.join(resultdir, kernel, test)):
				continue
	
			logs = []
			passes = os.listdir(os.path.join(resultdir, kernel, test))
	
			if not os.path.isfile(os.path.join(resultdir, kernel, test, passes[0], "irq-log")):
				continue
	
			for p in passes:
				irqlog = os.path.join(resultdir, kernel, test, p, "irq-log")
				if os.path.isfile(irqlog):
					logs += [irqlog]
	
			res = analyse.analyse (sys.argv + logs)
			avr = res["avr"]
			minimum = res["min"]
			maximum = res["max"]
			stddev = res["stddev"]
			print "| %(kernelstr)-20.20s | %(test)-10.10s | %(avr)4.1f | %(maximum)5.1f | %(minimum)4.1f | %(stddev)6.1f |" % vars()
			kernelstr = ""
	
		print "+----------------------+------------+------+-------+------+--------+"

#if True:
#	for test in tests_list:
#		os.system("ssh " + target_ip
