#!/usr/bin/python
#	This script automate/synchronise the different tests for realtime in linux.
#	Copyright (C) 2005  Kristian Benoit, Opersys inc.
#
#	This program is free software; you can redistribute it and/or
#	modify it under the terms of the GNU General Public License
#	as published by the Free Software Foundation; either version 2
#	of the License, or (at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


#import thread
import threading
import time
import os
import re
import sys
sys.path.append("scripts")
from setting import *


# Get the host's kernel version and config file.
version_file = os.popen ("ssh " + user + "@" + target_ip + " uname -r", "r")
pathinfo["kernel"] = re.sub("\n", "", version_file.readline())
kerneldir = pathinfo2path(pathinfo)
print "Results will go under " + kerneldir
if os.system("scp " + user + "@" + target_ip + ":/lib/modules/" + pathinfo["kernel"]  + "/build/.config " + kerneldir + "/config"):
	print "Cannot get the kernel config on the host."
	exit()

# Compile par-test on the host then insmod it.
if os.system ("ssh " + user + "@" + target_ip + " 'cd test/par-test ; echo $PWD ; make clean ; make -C /lib/modules/" + pathinfo["kernel"] + "/build/ SUBDIRS=$PWD modules ; sudo /sbin/insmod par-test.ko'"):
	print "Cannot compile/insmod par_test.ko on host."
	exit()

event = threading.Event()
for test_desc in tests_list:
	pathinfo["testname"] = test_desc["name"]
	for i in range(test_desc["nbpass"]):
		pathinfo["pass"] = "pass" + str(i)
		event.clear()
		print "starting " + test_desc["name"] + str(i)

		mythreads = []
		for test in test_desc["other_tests"]:
			testname = str(test)
			print "         starting " + testname + "..."
			mythreads.insert (0, threading.Thread(target=test, args=(event, pathinfo)))
			mythreads[0].setName(testname)
			mythreads[0].start()

		testname = str(test_desc["timed_test"])
		print "         starting " + testname + "..."
		mythreads.insert (0, threading.Thread(target=test_desc["timed_test"], args=(event, pathinfo)))
		mythreads[0].setName(testname)
		mythreads[0].start()

		print
		print "waiting for threads to be done..."
		for thrd in mythreads:
			thrd.join()
			print "         ... Thread '" + thrd.getName() + "' done"
			print 

		if threading.activeCount() != 1:
			print "ERROR there shouldnt be any more thread active, but there is."
			while threading.activeCount() != 1:
				pass

		print "All threads done"
		print
		print
		pathinfo.pop("pass", 0)
	pathinfo.pop("testname", 0)

os.system ("ssh " + user + "@" + target_ip + " sudo /sbin/rmmod par-test")
