import sys
import os
import time
import threading

# Comment the test you dont want and add your.
target_ip = "192.168.172.50"
logger_ip = "192.168.172.49"
hd_script = "./hd_script" # On target
lmbench_file = "localhost.localdomain.0" #The file is on the target
lmbench_path = "test/lmbench-2.0.4/results/i686-pc-linux-gnu"
analyse_test_files = "results/*" # The directory is on the logger machine
user = "stage"
path_order = ["base", "kernel", "testname", "pass"]
pathinfo = {"base" : "results"}
sleep_time = 10 #3.5*60

# From http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/82465
def _mkdir(newdir):
	"""works the way a good mkdir should :)
	- already exists, silently complete
	- regular file in the way, raise an exception
	- parent directory(ies) does not exist, make them as well
	"""
	if os.path.isdir(newdir):
		pass
	elif os.path.isfile(newdir):
		raise OSError("a file with the same name as the desired " \
					  "dir, '%s', already exists." % newdir)
	else:
		head, tail = os.path.split(newdir)
		if head and not os.path.isdir(head):
			_mkdir(head)
		#print "_mkdir %s" % repr(newdir)
		if tail:
			os.mkdir(newdir)

def pathinfo2path (info):
	path = []
	for i in path_order:
		if info.has_key(i):
			path += [info[i]]
		else:
			break
	path = os.path.join(*path)
	_mkdir(path)
	return path

# These 2 tests control the duration of the tests.
def start_lmbench(event, pathinfo):
	t1 = time.time()
	os.system("ssh " + user + "@" + target_ip + " ' cd test/lmbench-2.0.4/src ; make rerun'")
	delta_t = time.time()-t1
	event.set()

	print "Cleaning lmbench"
	path = pathinfo2path(pathinfo)
	timefile = open(os.path.join (path, "lmbench.time"), "a")
	timefile.write(str(delta_t) + "\n")
	timefile.close()

	intree = os.path.join(path, "lmbench.results")
	os.system("scp " + user + "@" + target_ip + ":" + os.path.join (lmbench_path, lmbench_file) + " " + intree)

	base = os.path.join(pathinfo["base"], "lmbench")
	_mkdir (base)
	inlmbench = os.path.join(base, pathinfo["kernel"] + '.' + pathinfo["testname"] + '.' +  pathinfo["pass"] + '.lmbench')
	
	os.link(intree, inlmbench)
	os.system("ssh " + user + "@" + target_ip + " mv -f " + os.path.join (lmbench_path, lmbench_file) + " " + os.path.join (lmbench_path, pathinfo["kernel"] + '.' + pathinfo["testname"] + '.' +  pathinfo["pass"] + '.lmbench'))

def start_sleeping (event, pathinfo):
	time.sleep(sleep_time)
	event.set()

# Those are wait for the previous to be done.
def start_logging (event, pathinfo):
	os.system("ssh " + user + "@" + logger_ip + " 'sudo /sbin/insmod par-log.ko'")

	event.wait()

	print "Cleaning IRQ"
	os.system("ssh " + user + "@" + logger_ip + " ' cat /proc/par_logger > results/irq-log'")
	os.system("scp " + user + "@" + logger_ip + ":" + analyse_test_files + " " + pathinfo2path(pathinfo))
	os.system("ssh " + user + "@" + logger_ip + " 'rm -f " + analyse_test_files + "'")
	os.system("ssh " + user + "@" + logger_ip + " sudo /sbin/rmmod par-log")

def start_pinging (event, pathinfo):
	pid_file = os.popen("sudo ping -fqs 10 -l 100000 " + target_ip + " > /dev/null & echo $!", "r")
	pid = int(pid_file.readline())
	event.wait()
	os.system("sudo kill -s 9 " + str(pid))
	pid_file.close()

def start_hd (event, pathinfo):
	pid_file = os.popen("ssh " + user + "@" + target_ip + " '" + hd_script + "& echo $!'", "r")
	pid = int(pid_file.readline())
	event.wait()
	os.system("ssh " + user + "@" + target_ip + " 'kill " + str(pid) + "'")
	pid_file.close()

def stop_hackbench (event, pathinfo):
	pid_file = os.popen("ssh " + user + "@" + target_ip + " ' ./stop_hackbench & echo $!'", "r")
	pid = int(pid_file.readline())
	event.wait()
	os.system("ssh " + user + "@" + target_ip + " 'kill " + str(pid) + "'")
	pid_file.close()

def start_hackbench (event, pathinfo):
	pid_file = os.popen("ssh " + user + "@" + target_ip + " ' ./start_hackbench & echo $!'", "r")
	pid = int(pid_file.readline())
	event.wait()
	os.system("ssh " + user + "@" + target_ip + " 'kill " + str(pid) + "'")
	pid_file.close()

def start_ltp (event, pathinfo):
	pid_file = os.popen("ssh " + user + "@" + target_ip + " ' ./run40& echo $!'", "r")
	pid = int(pid_file.readline())
	event.wait()
	os.system("ssh " + user + "@" + target_ip + " 'sudo killall -g run40'")
	os.system("ssh " + user + "@" + target_ip + " 'sudo killall -g runltp'")
	os.system("ssh " + user + "@" + target_ip + " 'sudo killall -g -s 9 pan'")
	pid_file.close()

def start_du (event, pathinfo):
	pid_file = os.popen("ssh " + user + "@" + target_ip + " ' du / 2>&1 /dev/null& echo $!'", "r")
	pid = int(pid_file.readline())
	event.wait()
	os.system("ssh " + user + "@" + target_ip + " 'kill " + str(pid) + "'")
	pid_file.close()

# Comment the test you dont want and add your. Name length should be <= 10.
tests_list = [
{"name" : "irq",		"nbpass" : 5, "timed_test" : start_sleeping,	"other_tests" : [start_logging]},
{"name" : "lmb",		"nbpass" : 5, "timed_test" : start_lmbench,		"other_tests" : []},
{"name" : "lmb-irq",	"nbpass" : 5, "timed_test" : start_lmbench,		"other_tests" : [start_logging]},
{"name" : "irq-pf",		"nbpass" : 5, "timed_test" : start_sleeping,	"other_tests" : [start_pinging, start_logging]},
{"name" : "lmb-pf",		"nbpass" : 5, "timed_test" : start_lmbench,		"other_tests" : [start_pinging]},
{"name" : "lmb-irq-pf",	"nbpass" : 5, "timed_test" : start_lmbench,		"other_tests" : [start_pinging, start_logging]},
{"name" : "lmb-irq-hd",	"nbpass" : 5, "timed_test" : start_lmbench,		"other_tests" : [start_hd, start_logging]},
{"name" : "dohell",		"nbpass" : 5, "timed_test" : start_sleeping,	"other_tests" : [start_ltp, start_hd, stop_hackbench, start_hackbench, start_ltp, start_pinging, start_du, start_logging]},
]

